//all functions are based off of participantManager (print, config, etc.)
var participantIdManager={};

participantIdManager.print=
function(msg){
   console.log(msg);
}

participantIdManager.init=
function(cb=null){
   let that=this;
   let action=function(){that.afterScripts(cb);};
   LABKEY.requiresScript(['crf/crfHTML.js'],action);
}

participantIdManager.afterScripts=
function(cb=null){
   crfHTML.init();
   if (cb) cb();
}

participantIdManager.set=
function(setup,data){
   this.setup=setup;
   this.data=data;
   this.updateCrfEntry=function(){;}
   this.mode='STUDY';
   //this.generateTable();
}

participantIdManager.setMode=
function(mode){
   this.mode=mode;
}

participantIdManager.getMode=
function(){
   return this.mode;
}

participantIdManager.setReadonly=
function(mode){
   if (!("readonly" in this)){
      this.readonly=new Object();
      this.readonly['LOCAL']=false;
      this.readonly['STUDY']=false;
   }
   if (mode=="LOCAL"){
      this.readonly[mode]=true;
      return;
   }
   this.readonly['STUDY']=true;
}

participantIdManager.isReadonly=
function(mode){
   if (mode=='LOCAL') return this.readonly['LOCAL'];
   return this.readonly['STUDY'];
}

participantIdManager.addSelectOptions=
function(mode=null){
   if (mode=="LOCAL") return;
   
   let input=this.getInputElement(mode);

   let fName='addParticipantSelectOptions';
   this.print(fName+' input '+input);


   //here the lookup is being populated (registrationData)
   let demoRows=this.setup.getRows('registrationData');
   this.print(fName+" demoRows: "+demoRows.length);
   let opts=new Object();
   for (let i=0;i<demoRows.length;i++){
      opt2[i+1]=this.setup.getParticipantLabel(demoRows[i]);
   }
   crfHTML.addSelectOptions(input,opts);
}

participantIdManager.updateElements=
function(mode=null){
   let fName='[updateElements]';
   //reset all values (some might be different depending on the call timing)

   //selector is with study
   //pM.inputManageStudy=this.parent.getElement(pM.inputManageStudyId);
}


participantIdManager.generateTable=
function(){
   let fName='[generateParticipantEntryField]:';
   this.print(fName);

   //this is HTML designator of area on page
	let formName=this.masterForm;
   this.print(fName+' master '+formName);

    
   this.table=crfHTML.createTable(formName);
	this.table.className='t2';
	let row=this.table.insertRow();
	
   //label for local ID
   let cell=crfHTML.createTblHeader(null,row);
	cell.setAttribute("colspan","1");
	cell.style.fontSize="20px";
	cell.style.textAlign="left";
   //Use study coding for participant field
   cell.innerText='Local ID';
	//cell.innerText=pM.participantField;


   //value
   let cellValue=row.insertCell();
   //cellValue.id=pM.cellValueId;

   let cellButton=row.insertCell();
   this.getInputButton('LOCAL');
   
   //second row for study id
   let rowStudy=this.table.insertRow();

   //label for study ID
   let cellStudy=crfHTML.createTblHeader(null,rowStudy);
	cellStudy.setAttribute("colspan","1");
	cellStudy.style.fontSize="20px";
	cellStudy.style.textAlign="left";
   //Use study coding for participant field
   cellStudy.innerText='Study ID';

	//selector for study id
   cellValue=rowStudy.insertCell();

   //manage
   cellButton=rowStudy.insertCell();
   this.print(fName+' done');
   this.getInputButton('STUDY');

}

participantIdManager.getRow=
function(mode=null){
   let row=this.table.rows[1];
   if (mode=="LOCAL")
      row=this.table.rows[0];
   return row;
}


participantIdManager.getValueCell=
function(mode="NONE"){
   return this.getRow(mode).cells[1];
}


participantIdManager.getButtonCell=
function(mode="NONE"){
   return this.getRow(mode).cells[2];
}

participantIdManager.getValueElement=
function(mode=null){
   return this.getValueCell(mode).firstChild;
}


participantIdManager.getInputElement=
function(mode=null){
   let fName='[getInputElement]';
   this.print(fName);
   let el=this.getValueElement(mode);
   if (el) return el;
   return this.createInputElement(mode);
}

participantIdManager.createInputElement=
function(mode=null){
   let elementType=this.getInputElementType(mode);
   let cell=this.getInputCell(mode);
   
   if (elementType=="input") el=crfHTML.createTextInput();
   if (elementType=="select") el=crfHTML.createSelect(new Object());
   this.print(fName+' input '+el);

   cell.replaceChildren(el);
   this.addSelectOptions();
 
   return el;
}

participantIdManager.getInputElementType=
function(mode=null){
   let fName='[getInputElementType]';
   this.print(fName);
   if (mode=="LOCAL") return "input";
   return "select";
}


participantIdManager.getTextElement=
function(mode=null){
   let fName='[getTextElement]';
   let el=this.getValueElement(mode);
   if (el) return el;
   el=crfHTML.createParagraph('');
   let cell=this.getValueCell(mode);
   //let oldEl=pM.getInputElement(mode);
   cell.replaceChildren(el);
   return el;
}


//get the button, create if not there yet
participantIdManager.getInputButton=
function(mode=null){
   let fName='[getInputManage]';
   //this.print(fName);
   //this prevents from having two inputs; it is either local or global from the outset
   let cell=this.getButtonCell(mode);
   let el=cell.firstChild;
   if (el) return el;
   el=crfHTML.createButton(null,cell);
   let that=this;
   el.onclick=function(){that.manageId(mode);};
   return el;
}

//callback that splits to edit or set/label mode

participantIdManager.manageId=
function(mode){
   let fName='[manageId]';
   this.print(fName);
   //this can happen after object was created, so make sure current
   //elements are used
   //this.updateElements();
   let x=this.getInputButton(mode);

   if (x.value=="Set"){
      this.setId(mode);
      return;
   }
   if (x.value=="Edit"){
      this.editId(mode);
      return;
   }
}

//set mode
participantIdManager.setId=
function(mode=null){
   let fName='[setId]';
   this.print(fName);
   let el=this.getInputElement(mode);

   this.print(fName+" value: "+el.value);
   let pId=el.value;
   let label=pId;
   if (mode!="LOCAL"){
      //extract from select
      if (el.value<0) return;
      let opt=el.options[el.selectedIndex];
      label=opt.text;
      pId=crfSetup.getStudyId(label);
      //label=label.replace(/ \(Local: /,':');
      //label=label.replace(/\)/,'');
   }
   this.setParticipantIdToCrfEntry(mode,pId);//no argument (should come from mode)
   this.print(fName+" new value "+pId);
   this.setLabelMode(mode,label);
   pM.updateCrfEntry();
}

participantIdManager.setLabelMode=
function(mode,label){
   let fName='[setLabelMode1]';

   this.print(fName+' id '+label);
   //this will give two for study and one entry for local
   //let ids=pId.split(':');
   let id=label;
   if (mode!='LOCAL'){
      if (label=='NOT SET')
         id=label;
      else
         id=crfSetup.getStudyId(label);
   }
      

   let textValue=this.getTextElement(mode);
   this.print(fName+' textElement '+textValue);
   textValue.innerText=id;

   if (mode!="LOCAL"){
      let loc=crfSetup.getLocalId(label);
      this.print(fName+' setting local id '+loc);
      if (loc && loc!='null'){
         //pM.getParticipantIdFromCrfEntry('LOCAL');
         let tValLocal=this.getTextElement('LOCAL');
         tValLocal.innerText=loc;
      }
      //this.setParticipantIdToCrfEntry(pM,loc,'LOCAL');
   }

   let x=this.getInputButton(mode);//getInputManage
   let readonly=this.isReadonly(mode);
   if (readonly){
      x.style.display="none";
   }
   x.value="Edit";

   
}

//edit mode
participantIdManager.editId=
function(mode){
   this.setEditMode(mode);
}


participantIdManager.setEditMode=
function(mode){

   let fName='[setEditMode1]';
   this.print(fName+' pM '+this+' mode '+mode);
   //input
   let el=this.getInputElement(mode);

   let x=this.getInputButton(mode);
   x.value="Set";

}

//manage interaction to storage/CRF and study/LabKey
participantIdManager.getParticipantField=
function(){
   return this.setup.getRows('studyData')[0]['SubjectColumnName'];
}

participantIdManager.getCrfEntryFieldName=
function(mode=null){
   if (mode=="LOCAL") return crfSetup.getLocalIdLabel();
   return crfSetup.getStudyIdLabel();
}

participantIdManager.setParticipantIdToCrfEntry=
function(mode,pId){
   let id=pId;
   this.data.getCrfEntry()[this.getCrfEntryFieldName(mode)]=id;
}

participantIdManager.getParticipantIdFromCrfEntry=
function(mode=null){
   return this.data.getCrfEntry()[this.getCrfEntryFieldName(mode)];
}

participantIdManager.verifyCrfStudyId=
function(){

   //is studyId already set for the crf
   let studyId=this.getParticipantIdFromCrfEntry('STUDY');
   if (!studyId) return;
   this.setReadonly('STUDY');
   this.setMode("STUDY");
   this.setLabelMode('STUDY',this.setup.getParticipantLabel(this.data.getCrfEntry()));
   //subject to content of localId
   let localId=this.getParticipantIdFromCrfEntry('LOCAL');
   if (localId) this.setReadonly('LOCAL');
   
}


